###############################################################################
#Post.pl                                                                     #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$postplver = "1 Gold - SP 1.3";

sub Post {
	if($username eq 'Guest' && $enable_guestposting == 0) { &fatal_error($txt{'165'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	my($filetype_info, $filesize_info);
	my( $subtitle, $x, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $msubject, $mattach, $mip, $mmessage, $mns, $quotestart);
	my $quotemsg = $INFO{'quote'};
	$threadid = $INFO{'num'};

	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$yyThreadLine);
	if( $mstate == 1 ) { &fatal_error($txt{'90'}); }

	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$cat = <FILE>;
	fclose(FILE);
	$curcat = $cat;
	fopen(FILE, "$boardsdir/$cat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$cat = <FILE>;
	fclose(FILE);

	$pollthread = 0;
	$polltxt{'1a'} =~ tr/+/ /;
	$polltxt{'2a'} =~ tr/+/ /;
	if ($INFO{'title'} eq $polltxt{'1a'}) { $pollthread = 1; }
	elsif ($INFO{'title'} eq $polltxt{'2a'}) { $pollthread = 2; }
	if ($pollthread == 2 && $useraddpoll == 0) { &fatal_error($txt{'1'}); }

	$notification = ! $enable_notification || $username eq 'Guest' ? '' : <<"~;";
    <tr>
      <td class="windowbg"><font size=2><b>$txt{'131'}:</b></font></td>
      <td class="windowbg"><input type=checkbox name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
    </tr>
~;

	$name_field = $realname eq '' ? qq~      <tr>
    <td width="140" class="windowbg"><font size="2"><b>$txt{'44'}:</b></font></td>
    <td class="windowbg"><input type=text name="name" size=25 value="$FORM{'name'}" maxlength="25" tabindex="2"></td>
      </tr>~ : qq~~;

	if($name_field){
		$namecheck = qq~
	if (checkForm.name.value == "") {
		alert("$txt{'75'}")
		checkForm.name.focus()
		return false
	}~;
	} else {
		$namecheck = '';
	}

	$email_field = $realemail eq '' ? qq~      <tr>
    <td width="140" class="windowbg"><font size="2"><b>$txt{'69'}:</b></font></td>
    <td class="windowbg"><font size="2"><input type=text name="email" size=25 value="$FORM{'email'}" maxlength="40" tabindex="3"></font></td>
      </tr>~ : qq~~;

	if($email_field){
		$emailcheck = qq~
	if (checkForm.email.value == "") {
		alert("$txt{'76'}")
		checkForm.email.focus()
		return false
	}~;
	} else {
		$emailcheck = '';
	}

	$sub = "";
	$settofield="subject";
	if( $threadid ne '' ) {
		fopen(FILE, "$datadir/$threadid.txt") || &fatal_error("201 $txt{'106'}: $txt{'23'} $threadid.txt");
		@messages = <FILE>;
		fclose(FILE);

		if($quotemsg ne '') {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns) = split(/\|/,$messages[$quotemsg]);
			$message=$mmessage;
			$message =~ s~<br>~\n~g;
			$message =~ s~\n{0,1}\[quote([^\]]*)\](.*?)\[/quote\]\n{0,1}~\n~isg;
			$message =~ s~\n*\[/*quote([^\]]*)\]\n*~~ig;

			$mname ||= $musername || $txt{'470'};
			$quotestart = int( $quotemsg / $maxmessagedisplay ) * $maxmessagedisplay;
			$message = qq~[quote author=$mname link=board=$currentboard;num=$threadid;start=$quotestart#$quotemsg date=$mdate\]$message\[/quote\]\n~;
			$msubject =~ s/\bre:\s+//ig;
			if ($mns eq "NS") {$nscheck="checked";}
			$message =~ s~\[whisper(.+?)\](.+?)\[\/whisper\]~~eisg; 
		}
		else {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mattache, $mip, $mmessage, $mns) = split(/\|/,$messages[0]);
			$msubject =~ s/\bre:\s+//ig;
		}
		$sub = "Re: $msubject";
		$settofield="message";
	}
	if ($pollthread && $username eq "Guest") {$guest_vote = 1;}
	if ($pollthread == 2) {
		$settofield="question";
		$sub = "$msubject";
	} else {
		if (!$enable_notification || $username eq 'Guest') {$notification = ""} else { $notification = qq~<tr>
                <td class="windowbg" width="135"><font size="2"><b>$txt{'131'}:</b></font></td>
                <td class="windowbg"><input type="checkbox" name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
              </tr>~;}
	}
	if(!$sub) { $subtitle = "<i>$txt{'33'}</i>"; }
	else { $subtitle = "<i>$sub</i>"; }
	if(!$sub){
		$subjectcheck = qq~
	if (checkForm.subject.value == "") {
		alert("$txt{'77'}")
		checkForm.subject.focus()
		return false
	}~;
	} else {
		$subjectcheck = '';
	}

	if($namecheck || $emailcheck || $subjectcheck) {
		$formcheck1 = qq~return validForm(this)\;return submitproc()~;
		$formcheck2 = qq~
<SCRIPT LANGUAGE="JAVASCRIPT" TYPE="TEXT/JAVASCRIPT">
<!-- Hide script from older browsers
function validForm(checkForm) {
$subjectcheck
$namecheck
$emailcheck
	return true
}
// End hiding script -->
</SCRIPT>~;
	} else {
		$formcheck1 = qq~return submitproc()~;
		$formcheck2 = '';
	}

	$yymain .= qq~
<table width="760" align="center" cellpadding=0 cellspacing=0>
  <tr>
    <td valign="bottom" colspan="2">
    <font size="2" class="nav"><B><img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$scripturl" class="nav">$mbname</a><br>
    <img src="$imagesdir/tline.gif" border="0" alt=""><img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$scripturl#$curcat" class="nav">$cat</a><br>
    <img src="$imagesdir/tline2.gif" border="0" alt=""><img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$cgi" class="nav">$boardname</a><br>
    <img src="$imagesdir/tline3.gif" border="0" alt=""><img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    $INFO{'title'} ( $subtitle )</B></font></td>
  </tr>
</table>
$formcheck2
~;
	$submittxt = "$txt{'105'}";
	$destination = "post2";
	$icon = "xx";
	$is_preview = 0;
	$post = "post";
	$preview = "preview";
	$yytitle = "$INFO{'title'}";
	&Postpage;
	if ($pollthread != 2) { &doshowthread; }
	&template;
	exit;
}

sub Postpage {
	my $extra;
	if(!$formcheck1){$formcheck1 = qq~return submitproc()~;}
	my($filetype_info, $filesize_info, $extensions);
	$extensions = join(" ", @ext);
	$filetype_info = $checkext == 1 ? qq~$fatxt{'2'} $extensions~ : qq~$fatxt{'2'} $fatxt{'4'}~;
	$filesize_info = $limit != 0 ? qq~$fatxt{'3'} $limit KB~ : qq~$fatxt{'3'} $fatxt{'5'}~;
	if ($is_preview) {$txt{'507'}=$txt{'771'};}
	$styletest = 0;
	fopen(TEMPLATE,"template.html") || die("$txt{'23'}: template.html");
	@outemplate = <TEMPLATE>;
	fclose(TEMPLATE);
	my $prevstyl;
	for($i=0;$i<@outemplate;$i++) {
		if($outemplate[$i] !~ m~\A\<style~i && $styletest == 0) { next } else { $styletest = 1 }
		if($outemplate[$i] =~ m~\A\<style~i) { $prevstyl .= qq~$outemplate[$i]~; next }
		if($outemplate[$i] =~ m~\A\<\/style~i ) { $prevstyl .= qq~$outemplate[$i]~; last }
		$prevstyl .= qq~$outemplate[$i]~;
	}

	fopen(FILE,"Variables/yabbchelp.txt") || die("$txt{'23'}: yabbchelp.txt");
	$hlptext = <FILE>;
	fclose(FILE);

	$normalquot = $txt{'704'};
	$simpelquot = $txt{'705'};
	$simpelcode = $txt{'706'};
	$message =~ s~<\/~\&lt\;/~isg;
	if($post eq "imsend") {
		if(!$INFO{'to'}) { $INFO{'to'} = $FORM{'to'};}
		if($INFO{'to'}) {$settofield="message";} else {$settofield="to";}
		$idinfo = "$INFO{'id'}";
if(!$INFO{'adminim'}) {
		$extra = qq~
      <tr>
        <td width="140" class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><b>$txt{'150'}</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}">
	<input type=text name="to" value="$INFO{'to'}" size="20" maxlength="50" tabindex="2">
	<font size="1">$txt{'748'}</font></td>
      </tr>
	~;
} else { $extra = qq~$adminim~; }

	}
	else {
	 $extra = qq~
      <tr>
        <td width="140" class="windowbg" bgcolor="$color{'windowbg'}"><font size="2"><b>$txt{'71'}:</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}">
        <select name="icon" onChange="showimage(); updatTopic();">
         <option value="xx"$ic1>$txt{'281'}
         <option value="thumbup"$ic2>$txt{'282'}
         <option value="thumbdown"$ic3>$txt{'283'}
         <option value="exclamation"$ic4>$txt{'284'}
         <option value="question"$ic5>$txt{'285'}
         <option value="lamp"$ic6>$txt{'286'}
         <option value="smiley"$ic7>$txt{'287'}
         <option value="angry"$ic8>$txt{'288'}
         <option value="cheesy"$ic9>$txt{'289'}
         <option value="laugh"$ic10>$txt{'290'}
         <option value="sad"$ic11>$txt{'291'}
         <option value="wink"$ic12>$txt{'292'}
        </select>
        <img src="$imagesdir/$icon.gif" name="icons" border=0 hspace=15></td>
      </tr>
	 ~;
	if ($realname eq '' && $threadid ne '') {$settofield="name";}
	}
	$yymain .= qq~

<script language="JavaScript1.2" type="text/javascript">
<!--

var ie = document.all;
var postas = '$post';
var namefield = '$realname';
var mailfield = '$realemail';
function checkForm(theForm) {
if (ie) { theForm.message.createTextRange().execCommand("Copy"); }
if (theForm.subject.value == "") { alert("$txt{'77'}"); theForm.subject.focus(); return false }
if (postas == "imsend") { if (theForm.to.value == "") { alert("$txt{'752'}"); theForm.to.focus(); return false } }
else {
	if (namefield == "") {
		if (theForm.name.value == "" || theForm.name.value == "_" || theForm.name.value == " ") { alert("$txt{'75'}"); theForm.name.focus(); return false }
		if (theForm.name.value.length > 25)  { alert("$txt{'568'}"); theForm.name.focus(); return false }
	}
	if (mailfield == "") {
		if (theForm.email.value == "") { alert("$txt{'76'}"); theForm.email.focus(); return false }
		if (! checkMailaddr(theForm.email.value)) { alert("$txt{'500'}"); theForm.email.focus(); return false }
	}
}
if (theForm.message.value == "") { alert("$txt{'78'}"); theForm.message.focus(); return false }
return true
}
//-->
</script>

<table width="760" border="0" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">~;
if($INFO{'adminim'} || $INFO{'action'} eq "imgroups") {
$yymain .= qq~
<form action="$cgi;action=imgroups" method="post" name="postmodify" onSubmit="return submitproc()">~;
} else {
$yymain .= qq~
<form action="$cgi;action=$destination" method="post" name="postmodify" ENCTYPE="multipart/form-data" onSubmit="return checkForm(this); return submitproc()">
}
$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
~; 

 $moresmilieslist = ""; 
 $more_smilie_array = ""; 
 $i=0; 
 if ($showadded eq 1){
 while($SmilieURL[$i]) { 
  if ($SmilieURL[$i]=~ /\//i) {$tmpurl = $SmilieURL[$i];} else {$tmpurl = qq~$imagesdir/$SmilieURL[$i]~;}
  $moresmilieslist .= qq~      document.write("<img src='$tmpurl' align=bottom alt="+'"'+"$SmilieDescription[$i]"+'"'+" border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand'>$SmilieLinebreak[$i] ");\n~; 
  $tmpcode = $SmilieCode[$i];
  $tmpcode =~ s/\&quot;/"+'"'+"/g;
  &FromHTML($tmpcode);
  $tmpcode =~ s/&#36;/\$/g;
  $tmpcode =~ s/&#64;/\@/g;
  $more_smilie_array .= qq~" $tmpcode", ~; 
  $i++; 
 } 
}
if ($showsmdir eq 1){
 opendir(DIR, "$smiliesdir"); 
  @contents = readdir(DIR); 
 closedir(DIR); 
 foreach $line (sort {uc($a) cmp uc($b)} @contents){ 
  ($name, $extension) = split (/\./, $line); 
  if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i ){ 
   if ($line !~ /banner/i) { 
    $moresmilieslist .= qq~      document.write("<img src='$smiliesurl/$line' align='bottom' alt='$name' border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand'>$SmilieLinebreak[$i] ");\n~; 
    $more_smilie_array .= qq~" [smiley=$line]", ~; 
    $i++ 
   } 
  } 
 } 
 }
 $more_smilie_array .= qq~""~; 
 
 $yymain .= qq~ 
 moresmiliecode = new Array($more_smilie_array) 
 
 function MoreSmilies(i) { 
  AddTxt=moresmiliecode[i]; 
  AddText(AddTxt); 
 }  

~;
if ($smiliestyle eq 1){
	$smiliewinlink = "$scripturl?action=smilieput";
}
else{
	$smiliewinlink = "$scripturl?action=smilieindex";
}
$yymain .= qq~
function smiliewin() {
  window.open("$smiliewinlink", 'list', 'width=$winwidth,height=$winheight, scrollbars=yes');
}

function showimage() {
   document.images.icons.src="$imagesdir/"+document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value+".gif";
}
//-->
</script>
    <input type="hidden" name="threadid" value="$threadid">
    <input type=hidden name="postid" value="$postid">
    <input type=hidden name="info" value="$idinfo">
    <table class="titlebg" bgcolor="$color{'titlebg'}" width="100%">
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}" align="left"><font size="2" class="text1" color="$color{'titletext'}"><b>$yytitle</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" align="right"><img name="prevwin" id="prevwin" src="$imagesdir/preview.gif" border="0" alt="$npftxt{'05'}" onClick="enabPrev();"><img name="helpwin" id="helpwin" src="$imagesdir/help1.gif" border="0" alt="$txt{'119'}" onClick="enabHelp();"></td>
      </tr>
    </table>
    </td>
  </tr>~;

## [Poll Mod Options] ##
	if ($pollthread) {
		$maxpq ||= 60;
		$maxpo ||= 50;
		$maxpc ||= 0;
		$numpolloptions ||= 8;

		if ($guest_vote) {$gvchecked = " checked";}
		if ($hide_results) {$hrchecked = " checked";}
		if ($multi_choice) {$mcchecked = " checked";}
		$yymain .= qq~
        <tr>
          <td bgcolor="$color{'windowbg2'}" class="windowbg2">
            <input type="hidden" name="pollthread" value="$pollthread">
            <table width="100%" cellpadding="3" cellspacing="0" border="0">
              <tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'6'}:</b></font></td>
                <td align="left"><input type="text" size="40" name="question" value="$poll_question" maxlength="$maxpq"></td>
              </tr><tr>
                <td width="23%" align="left">&nbsp;</td>
                <td align="left">
                  <table cellpadding="0" cellspacing="0" border="0">~;

		for(my $i = 1; $i <= $numpolloptions; $i++) {
			$yymain .= qq~
                    <tr>
                      <td align="right"> &nbsp; <font size="2">$polltxt{'7'} $i: &nbsp;</font></td>
                      <td align="left"><input type="text" size="25" maxlength="$maxpo" name="option$i" value="$options[$i]"></td>
                    </tr>~;
		}
		$yymain .= qq~
                  </table>
                </td>~;

		if ($maxpc > 0) {
			$yymain .= qq~
             </tr><tr>
                <td valign=top class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$polltxt{'59'}:</b></font></td>
                <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><textarea name="poll_comment" rows="3" cols="60" wrap="soft" onkeyup="if (document.postmodify.poll_comment.value.length > $maxpc) {document.postmodify.poll_comment.value = document.postmodify.poll_comment.value.substring(0,$maxpc)}">$poll_comment</textarea></font></td>~;
		}

		$yymain .= qq~
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'32'}</b></font></td>
                <td align="left"><input type="checkbox" name="guest_vote" value="1"$gvchecked> <font size="1">$polltxt{'54'}</font></td>
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'26'}</b></font></td>
                <td align="left"><input type="checkbox" name="hide_results" value="1"$hrchecked> <font size="1">$polltxt{'55'}</font></td>
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'58'}</b></font></td>
                <td align="left"><input type="checkbox" name="multi_choice" value="1"$mcchecked> <font size="1">$polltxt{'56'}</font></td>
              </tr>

            </table>
          </td>
        </tr>~;
	}

## [/Poll Mod Options] ##

	if ($pollthread != 2 || ($pollthread == 2 && $username eq 'Guest')) { $yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">

    <table width="100%" cellpadding="0" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
	<tr>
        <td width="100%" colspan="2" align="right" class="windowbg2" bgcolor="$color{'windowbg2'}">
	  <iframe id="SaveTopic" name="SaveTopic" width="600" height="0" marginwidth="0" marginheight="0" border="0" frameborder="0" style="display: inline; visibility: hidden"></iframe>
	  <iframe id="SaveFrame" name="SaveFrame" width="600" height="0" marginwidth="0" marginheight="0" border="0" frameborder="0" style="border-top: $color{'bordercolor'} 1px solid; visibility: hidden; display: inline"></iframe>
	  </td>
      </tr>
    </table>

    </td>
  </tr><tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">~;
		if ($pollthread == 2 ) {$extra = "";} else { $yymain .= qq~
	<tr>
	<td valign="top">

    <table width="100%" cellpadding="0" cellspacing="0">
	<tr>
        <td width="140" class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><b>$txt{'70'}:</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><input type=text name="subject" value="$sub" size="28" maxlength="50" tabindex="1" onChange="updatTopic()"></font></td>
      </tr>
~;
		}
		$yymain .= qq~
$name_field
$email_field
$extra
    </table>
	</td><td align="left" valign="bottom" bgcolor="$color{'windowbg'}" class="windowbg">
~;
if($enable_ubbc && $showyabbcbutt) {
	$yymain .= qq~
	<div style="width: 400; height: 44; left: 0; top: 0; position: relative; z-index: 0; margin: 0px; padding: 0px;">
	<div id="ubbuttons" style="width: 400; height: 44; left: 0; top: 0; position: relative; z-index:1; margin: 0px; padding: 0px;">
	  <nobr>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          HAND = "onmouseover=this.style.cursor='hand'";
          document.write("<img src='$imagesdir/tele.gif' onclick='teletype();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'440'}' border='0'>");
          document.write("<img src='$imagesdir/code.gif' onclick='showcode();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'259'}' border='0'>");
          document.write("<img src='$imagesdir/quote2.gif' onclick='quote();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'260'}' border='0'>");
          document.write("<img src='$imagesdir/list.gif' onclick='bulletset();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'261'}' border='0'>");
          document.write("<img src='$imagesdir/glow.gif' onclick='glow();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'442'}' border='0'>");
          document.write("<img src='$imagesdir/shadow.gif' onclick='shadset();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'443'}' border='0'>");
          document.write("<img src='$imagesdir/move.gif' onclick='move();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'439'}' border='0'>");
          document.write("<img src='$imagesdir/pre.gif' onclick='pre();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'444'}' border='0'>");
          document.write("<img src='$imagesdir/left.gif' onclick='left();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'445'}' border='0'>");
          document.write("<img src='$imagesdir/center.gif' onclick='center();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'256'}' border='0'>");
          document.write("<img src='$imagesdir/right.gif' onclick='right();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'446'}' border='0'>");
          document.write("<img src='$imagesdir/hr.gif' onclick='hr();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'531'}' border='0'>");
          document.write("<img src='$imagesdir/flash.gif' onclick='flash();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'433'}' border='0'>");
          document.write("<img src='$imagesdir/url.gif' onclick='hyperlink();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'257'}' border='0'>");
          document.write("<img src='$imagesdir/ftp.gif' onclick='ftp();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'434'}' border='0'>");
          document.write("<img src='$imagesdir/img.gif' onclick='image();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'435'}' border='0'>");
          document.write("<img src='$imagesdir/email2.gif' onclick='emai1();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'258'}' border='0'>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
	  </nobr><br><nobr>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          document.write("<img src='$imagesdir/bold.gif' onclick='bold();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'253'}' border=0>");
          document.write("<img src='$imagesdir/italicize.gif' onclick='italicize();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'254'}' border='0'>");
          document.write("<img src='$imagesdir/underline.gif' onclick='underline();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'255'}' border='0'>");
          document.write("<img src='$imagesdir/strike.gif' onclick='strike();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'441'}' border='0'>");
          document.write("<img src='$imagesdir/sup.gif' onclick='superscript();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'447'}' border='0'>");
          document.write("<img src='$imagesdir/sub.gif' onclick='subscript();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'448'}' border='0'>");
          document.write("<img src='$imagesdir/face.gif' onclick='fontcolorset();' "+HAND+" align=absmiddle width=23 height=22 alt='$npftxt{'08'}' border='0'>");
          document.write("<img src='$imagesdir/bgcolor.gif' onclick='fontbackgrset();' "+HAND+" align=absmiddle width=23 height=22 alt='$npftxt{'09'}' border='0'>");
          document.write('<select name="fontface" onchange="if(this.options[this.selectedIndex].value) fontfce(this.options[this.selectedIndex].value);" style="width: 80px; margin-left: 2px; margin-right: 1px; font-size: 9px">');
          document.write('<option value="" selected>$txt{'533'}</option>');
          document.write('<option value="Verdana" style="font-family: Verdana">Verdana</option>');
          document.write('<option value="Arial" style="font-family: Arial">Arial</option>');
          document.write('<option value="Courier" style="font-family: Courier">Courier</option>');
          document.write('<option value="Courier New" style="font-family: Courier New">Courier New</option>');
          document.write('</select>');
          document.write('<select name="fontsize" onchange="if(this.options[this.selectedIndex].value) fntsize(this.options[this.selectedIndex].value);" style="width: 29px; margin-left: 1px; margin-right: 2px; font-size: 9px">');
          document.write('<option value="">-</option>');
          document.write('<option value="1">1</option>');
          document.write('<option value="2" selected>2</option>');
          document.write('<option value="3">3</option>');
          document.write('<option value="4">4</option>');
          document.write('<option value="5">5</option>');
          document.write('<option value="6">6</option>');
          document.write('<option value="7">7</option>');
          document.write('</select>');
          document.write("<img src='$imagesdir/table.gif' onclick='table();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'436'}' border='0'>");
          document.write("<img src='$imagesdir/tr.gif' onclick='trow();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'437'}' border='0'>");
          document.write("<img src='$imagesdir/td.gif' onclick='tcol();' "+HAND+" align=absmiddle width=23 height=22 alt='$txt{'449'}' border='0'>");
          document.write("<img src='$imagesdir/me.gif' onclick='me();' "+HAND+" align=absmiddle width=23 height=22 alt='$npftxt{'11'}' border='0'>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
	  </nobr>
	<div id="fontcolor" style="position: absolute; z-index: 2; width: 58px; top: 44px; left: 104px; background-color: #CCCCCC; border: black 1px solid; margin: 0px; padding: 0px; visibility: hidden;">
	<input type="button" style="width: 14px; height: 14px; background-color: black; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Black'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: red; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Red'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: yellow; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Yellow'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: pink; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Pink'), fontcolorset()"><br>
	<input type="button" style="width: 14px; height: 14px; background-color: green; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Green'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: orange; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Orange'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: purple; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Purple'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: blue; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Blue'), fontcolorset()"><br>
	<input type="button" style="width: 14px; height: 14px; background-color: beige; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Beige'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: brown; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Brown'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: teal; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Teal'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: navy; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Navy'), fontcolorset()"><br>
	<input type="button" style="width: 14px; height: 14px; background-color: maroon; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Maroon'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: limegreen; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('LimeGreen'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: gray; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('Gray'), fontcolorset()"><input type="button" style="width: 14px; height: 14px; background-color: white; margin: 0px; border-width: 1px; border-style: outset" onclick="showcolor('White'), fontcolorset()">
	</div>
	<div id="fontbackgr" style="position: absolute; z-index: 3; width: 58px; top: 44px; left: 160px; background-color: #CCCCCC; border: black 1px solid; margin: 0px; padding: 0px; visibility: hidden;">
	<input type="button" style="width: 14px; height: 14px; background-color: black; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Black'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: red; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Red'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: yellow; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Yellow'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: pink; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Pink'), fontbackgrset()"><br>
	<input type="button" style="width: 14px; height: 14px; background-color: green; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Green'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: orange; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Orange'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: purple; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Purple'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: blue; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Blue'), fontbackgrset()"><br>
	<input type="button" style="width: 14px; height: 14px; background-color: beige; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Beige'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: brown; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Brown'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: teal; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Teal'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: navy; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Navy'), fontbackgrset()"><br>
	<input type="button" style="width: 14px; height: 14px; background-color: maroon; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Maroon'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: limegreen; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('LimeGreen'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: gray; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('Gray'), fontbackgrset()"><input type="button" style="width: 14px; height: 14px; background-color: white; margin: 0px; border-width: 1px; border-style: outset" onclick="showbackgr('White'), fontbackgrset()">
	</div>
	<div id="bullets" style="position: absolute; z-index: 4; width: 58px; top: 22px; left: 33px; background-color: #CCCCCC; border: black 1px solid; margin: 0px; padding: 0px; visibility: hidden;">
	<input type="button" value="$npftxt{'15'}" style="width: 54px; height: 15px; font-size: 8px; font-weight: bold; margin: 1px; border-width: 1px; border-style: outset"  onclick="list(), bulletset()">
	<img src="$imagesdir/bull-redball.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-redball'), bulletset()"><img src="$imagesdir/bull-greenball.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-greenball'), bulletset()"><img src="$imagesdir/bull-blueball.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-blueball'), bulletset()"><img src="$imagesdir/bull-blackball.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-blackball'), bulletset()"><br>
	<img src="$imagesdir/bull-redsq.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-redsq'), bulletset()"><img src="$imagesdir/bull-greensq.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-greensq'), bulletset()"><img src="$imagesdir/bull-bluesq.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-bluesq'), bulletset()"><img src="$imagesdir/bull-blacksq.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-blacksq'), bulletset()"><br>
	<img src="$imagesdir/bull-redpin.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-redpin'), bulletset()"><img src="$imagesdir/bull-greenpin.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-greenpin'), bulletset()"><img src="$imagesdir/bull-bluepin.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-bluepin'), bulletset()"><img src="$imagesdir/bull-blackpin.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-blackpin'), bulletset()"><br>
	<img src="$imagesdir/bull-redcheck.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-redcheck'), bulletset()"><img src="$imagesdir/bull-greencheck.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-greencheck'), bulletset()"><img src="$imagesdir/bull-bluecheck.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-bluecheck'), bulletset()"><img src="$imagesdir/bull-blackcheck.gif" style="width: 8px; height: 8px; background-color: #CCCCCC; margin: 3px; cursor: pointer; cursor: hand;" onclick="showbullets('bull-blackcheck'), bulletset()"><br>
	</div>
	<div id="shads" style="position: absolute; z-index: 5; width: 47px; top: 22px; left: 114px; background-color: #CCCCCC; border: black 1px solid; margin: 0px; padding: 0px; visibility: hidden;">
	<img src="$imagesdir/shad-lt.gif" style="width: 15px; height: 15px; margin: 0px; cursor: pointer; cursor: hand;" onclick="showshadow('topleft'), shadset()"><img src="$imagesdir/shad-t.gif" style="width: 15px; height: 15px; margin: 0px; cursor: pointer; cursor: hand;" onclick="showshadow('top'), shadset()"><img src="$imagesdir/shad-rt.gif" style="width: 15px; height: 15px; margin: 0px; cursor: pointer; cursor: hand;" onclick="showshadow('topright'), shadset()"><br>
	<img src="$imagesdir/shad-l.gif" style="width: 15px; height: 15px; margin: 0px; cursor: pointer; cursor: hand;" onclick="showshadow('left'), shadset()"><img src="$imagesdir/shad-0.gif" style="width: 15px; height: 15px; margin: 0px;"><img src="$imagesdir/shad-r.gif" style="width: 15px; height: 15px; margin: 0px; cursor: pointer; cursor: hand;" onclick="showshadow('right'), shadset()"><br>
	<img src="$imagesdir/shad-bl.gif" style="width: 15px; height: 15px; margin: 0px; cursor: pointer; cursor: hand;" onclick="showshadow('bottomleft'), shadset()"><img src="$imagesdir/shad-b.gif" style="width: 15px; height: 15px; margin: 0px; cursor: pointer; cursor: hand;" onclick="showshadow('bottom'), shadset()"><img src="$imagesdir/shad-br.gif" style="width: 15px; height: 15px; margin: 0px; cursor: pointer; cursor: hand;" onclick="showshadow('bottomright'), shadset()"><br>
	</div>
	</div>

        <script language="JavaScript1.2" type="text/javascript">
        <!--
	  var useNS6 = document.getElementById && !document.all ? 1:0;
	  var fontcl = false;
	  var fontbg = false;
	  var bullon = false;
	  var shadon = false;

	  function fontcolorset() {
		if(fontcl == false) {
			fontcl = true;
			if (document.all) fontcolor.style.visibility="visible";
			else { if (useNS6) document.getElementById("fontcolor").style.visibility = "visible"; }
		} else {
			fontcl = false;
			if(document.all) fontcolor.style.visibility="hidden";
			else { if(useNS6) document.getElementById("fontcolor").style.visibility = "hidden"; }
		}
	  }

	  function fontbackgrset() {
		if(fontbg == false) {
			fontbg = true;
			if (document.all) fontbackgr.style.visibility="visible";
			else { if (useNS6) document.getElementById("fontbackgr").style.visibility = "visible"; }
		} else {
			fontbg = false;
			if(document.all) fontbackgr.style.visibility="hidden";
			else { if(useNS6) document.getElementById("fontbackgr").style.visibility = "hidden"; }
		}
	  }

	  function bulletset() {
		if(bullon == false) {
			bullon = true;
			if (document.all) bullets.style.visibility="visible";
			else { if (useNS6) document.getElementById("bullets").style.visibility = "visible"; }
		} else {
			bullon = false;
			if(document.all) bullets.style.visibility="hidden";
			else { if(useNS6) document.getElementById("bullets").style.visibility = "hidden"; }
		}
	  }

	  function shadset() {
		if(shadon == false) {
			shadon = true;
			if (document.all) shads.style.visibility="visible";
			else { if (useNS6) document.getElementById("shads").style.visibility = "visible"; }
		} else {
			shadon = false;
			if(document.all) shads.style.visibility="hidden";
			else { if(useNS6) document.getElementById("shads").style.visibility = "hidden"; }
		}
	  }

        //-->
        </script>
	</div>
~;
} else {
	$yymain .= qq~&nbsp;~;
}
	$yymain .= qq~
	</td></tr>
    </table>
    </td>
  </tr>
~;
	}
## [Poll Mod Options] ##

	if ($pollthread != 2) { # if not adding a poll to an existing thread, display standard post page inputs

## [/Poll Mod Options] ##

  $yymain .= qq~

  <tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
	<tr>
        <td width="135" valign=top class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><b>$txt{'72'}:</b></font>
                  <br><br>~;
### Add More Smilies 3.0 - Smiley Block ###
	if ($SmilieURL[0] eq "") {&LoadSmilies;}

	$showmore = ""; 
	$smilie_list = "";
	$smilie_more = "";
	$smilie_block = "";
	$smilie_url_array = "";
	for( my $i = 0; $i < @SmilieURL; $i++ ) {
		if ($SmilieURL[$i] =~ /\//i) {$tmpurl = $SmilieURL[$i];} else {$tmpurl = qq~$smiliesurl/$SmilieURL[$i]~;}
		($tmpCode, $dummy) = split (/\s+/, $SmilieCode[$i]); 
		$tmpCode =~ s/'/&#39;/g;
		if ($SmilieOption[$i] % 2 == 1) { $smilie_list .= qq~
                    document.write("<img src='$tmpurl' onclick='javascript:AddText(" + '" $tmpCode"' + ")' align='bottom' alt='$SmilieDescription[$i]' border='0' style='cursor:hand'> ");~;
		}
		if (($SmilieOption[$i] / 2) % 2 == 1) {$smilie_block .= qq~
                    document.write("<option value=" + '" $tmpCode"' + ">$SmilieDescription[$i]</option>");~;
			$smilie_url_array .= qq~"$tmpurl", ~;
		}
		if (($SmilieOption[$i] / 4) % 2 == 1) {$showmore = 1;}
	}
	$smilie_url_array .= qq~""~;

	if ($showmore == 1 && ($show_smilie_block != 1 || $smilie_block eq "")) {$smilie_more = qq~
                    document.write('<br><a href="$scripturl?action=smilieindex" target="_blank" onclick="' + "javascript: window.open('$scripturl?action=smilieindex', 'list', 'width=100,height=100,left=0,top=0,scrollbars=yes'); return false" + '">$smi_txt{'8'}</a>');~;
	}

	if ($show_smilie_block == 1 && $smilie_block ne "") {$yymain .= qq~
               <script language="JavaScript1.2" type="text/javascript">
               <!--
               smilieurl = new Array($smilie_url_array)
               smiliecode = new Array($smilie_code_array)

               if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {

                 document.write('<table border="0" cellpadding="3" callspacing="0" bgcolor="white" style="border-style:solid; border-width:1px; border-color:$color{'bordercolor'}" align="center"><tr>');
                 document.write('<td height="20" width="110" align="center" valign="top"><select name="smiliextra_list" onchange="document.images.smiliextra_image.src= smilieurl[document.postmodify.smiliextra_list.selectedIndex]" style="width:110px; font-size:7pt">');$smilie_block
                 document.write('</select></td>');
                 document.write('</tr><tr>');
                 document.write('<td height="60" align="center" valign="middle" style="height:60px"><img name="smiliextra_image" src="'+smilieurl[0]+'" alt="" border="0" onclick="javascript:AddText(document.postmodify.smiliextra_list.options[document.postmodify.smiliextra_list.selectedIndex].value)" style="cursor:hand"></td>');
                 document.write('</tr><tr>');
                 document.write('<td height="15" align="center" valign="middle"><font size="1"><a href="$scripturl?action=smilieindex" target="_blank" onclick="' + "javascript: window.open('$scripturl?action=smilieindex', 'list', 'width=100,height=100,left=0,top=0,scrollbars=yes'); return false" + '">$smi_txt{'9'}</a></font></td>');
                 document.write('</tr></table>');
               }

               //-->
               </script>~;
	}
### Add More Smilies 3.0 - Smiley Block ###
		$yymain .= qq~
	  </td>
        <td colspan="2" class="windowbg2" bgcolor="$color{'windowbg2'}" align="left">
        <textarea name="message" rows="10" cols="85" wrap="soft" style="width: 595px; border: $color{'bordercolor'} 1px solid; padding: 5px;" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" tabindex="4">$message</textarea></td>
	</tr>
~;
# File Attachment's Browse Box Code
if ($allowattach == 1 && ($action eq 'post' || $action eq 'post2') && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) {
$yymain .= qq~
<tr>
	<td valign="top" class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><b>$fatxt{'6'}</b></font></td>
	<td colspan="2" class="windowbg2" bgcolor="$color{'windowbg2'}">
	<table width="100%" cellpadding="0" cellspacing="0">
	<tr>
		<td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="file" name="file" size="35"></td>
		<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="1">$filetype_info<br>$filesize_info</font></td>
	</tr>
	</table>
	</td>
</tr>
~;
if( ($is_preview == 1) && $FORM{'file'} ) {
$yymain .= qq~
<tr>
	<td align="right" class="windowbg2" bgcolor="$color{'windowbg2'}"></td>
	<td colspan="2" class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="1" color="#FF0000">$fatxt{'7'}</font></td>
</tr>
~;
}

}
# /File Attachment's Browse Box Code
$yymain .= qq~
	<tr>
	  <td width="135" valign=top class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2>&nbsp;</font></td>
        <td  class="windowbg2" bgcolor="$color{'windowbg2'}" align="left" valign="top">
	<img src="$imagesdir/green1.gif" name="chrwarn" height="8" width="8" border="0" vspace="0" hspace="0" align="absmiddle">
	<font size="1">$npftxt{'01'} <input value="$MaxMessLen" size="3" name="msgCL" class="windowbg2" style="border: 0px; font-size: 11px; width: 40px; padding: 1px" disabled></font><br>
	<img src="$imagesdir/grey1.gif" name="savewarn" height="8" width="8" border="0" vspace="0" hspace="0" align="absmiddle">
	<font size="1">$npftxt{'02'} <input value="0" size="3" name="msgCB" class="windowbg2" style="border: 0px; font-size: 11px; width: 40px; padding: 1px" disabled></font>
	  </td>
        <td valign=middle class="windowbg2" bgcolor="$color{'windowbg2'}">
~;
### Add More Smilies 3.0 - Smiley List ###

	if ($smilie_list ne "" || $smilie_more ne "" ) {$yymain .= qq~

                  <script language="JavaScript1.2" type="text/javascript">
                  <!--
                  if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {$smilie_list$smilie_more
                  }
                  else { document.write("<font size='1'>$txt{'215'}</font>"); }
                  //-->
                  </script>
                  <noscript>
                    <font size="1">$txt{'215'}</font>
                  </noscript>
              ~;
	}
### Add More Smilies 3.0 - Smiley List ###

		$yymain .= qq~
        </td>
    </table>
    </td>
  </tr><tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="135"><font size=2><b>$npftxt{'03'}:</b></font></td>
        <td  class="windowbg" bgcolor="$color{'windowbg'}" ><input type="checkbox" name="clautosave" onClick="if (this.checked) enabSave(); else disabSave();"> <font size="1"> $npftxt{'04'}</font></td>
      </tr>
$notification
$lastmod
      <tr>
        <td width="135" class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><b>$txt{'276'}:</b></font></td>
        <td  class="windowbg" bgcolor="$color{'windowbg'}"> <input type=checkbox name="ns" value="NS"$nscheck> <font size="1"> $txt{'277'}</font></td>
      </tr>
    </table>
    </td>
  </tr>~;
	}
	$yymain .= qq~
  </tr>~;
	}
	$message=$hlptext;
	&wrap;
	$displayname = $settings[1];
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	&wrap2;
	$hlptext=$message;
	$yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">
    <table class="titlebg" bgcolor="$color{'titlebg'}" align="center" width="100%">
      <tr>
        <td align="center" width="33%" class="titlebg" bgcolor="$color{'titlebg'}">
		<input type='hidden' name='holdstyle' value='$prevstyl'>
        </td>
        <td align="center" width="34%" class="titlebg" bgcolor="$color{'titlebg'}">
		<input type="submit" name="$post" value="$submittxt" accesskey="s" style="width: 75px" tabindex="5">
~;
unless ($pollthread == 2) {$yymain .= qq~		<input type="submit" name="$preview" value="$txt{'507'}" accesskey="p" style="width: 75px">~;}
unless ($is_preview){$yymain .= qq~  
<input onclick="DoSpell('postmodify', 'message')" type="button" value="Check Spelling" name="SpellChk.x">           
     <input type="reset" value="$txt{'278'}" accesskey="r" style="width: 75px">~;}

$yymain.=qq~
        </td>
        <td align="left" width="33%" class="titlebg" bgcolor="$color{'titlebg'}">
	        <font size="1" color="$color{'titletext'}">$txt{'329'}</font><br>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
	      <FORM name=SPELLDATA>
        <P><FONT face="Times New Roman, Times, serif"><INPUT type=hidden 
        name=formname> <INPUT type=hidden name=subjectname> <INPUT type=hidden 
        name=messagebodyname> <INPUT type=hidden value=body3 name=TextBox3> 
        <INPUT type=hidden value=body4 name=TextBox4> <INPUT type=hidden 
        name=companyID> <INPUT type=hidden name=language> <INPUT type=hidden 
        name=opener> <INPUT type=hidden name=formaction> 
           </FONT></P></FORM>
~;
unless ($pollthread == 2) {
$yymain.=qq~
	<script language="JavaScript1.2" src="$yabbcjspath" type="text/javascript"></script>
	<script language="JavaScript1.2">
	<!--
	var ie=document.all
	var ns6=document.getElementById&&!document.all
	var supportsKeys = false
	var autosave = false
	var autoprev = false
	var helpopen = false
	var noalert = true, gralert = false, rdalert = false, clalert = false;
	var prevsec = 5
	var prevtxt

	function tick() {
	  calcCharLeft()
	  if (!supportsKeys) timerID = setTimeout("tick()",1000)
	}

	function enabSave() {
		autosave = true
		document.postmodify.message.focus();
		if (ie) autoSaveMsg();
		tick();
	}

	function disabSave() {
		autosave = false
		document.postmodify.message.focus();
		document.images.savewarn.src="$imagesdir/grey1.gif";
		document.postmodify.msgCB.value = "";
		tick();
	}

	var topicfirst = true;

	function enabPrev() {
		if ( autoprev == false ) {
			autoprev = true
			topicfirst = true
			document.getElementById("SaveFrame").style.visibility = "visible";
			document.getElementById("SaveFrame").style.height = "240";
			document.getElementById("SaveFrame").style.width = "600";
			document.getElementById("SaveTopic").style.visibility = "visible";
			document.getElementById("SaveTopic").style.height = "35";
			document.getElementById("SaveTopic").style.width = "600";
			document.postmodify.message.focus();
			document.images.prevwin.alt = "$npftxt{'12'}";
			document.images.prevwin.src="$imagesdir/preview1.gif";
			document.images.helpwin.src="$imagesdir/help1.gif";
			helpopen = false
			autoPreview();
		}
		else {
			autoprev = false
			document.getElementById("SaveFrame").style.visibility = "hidden";
			document.getElementById("SaveFrame").style.height = "0";
			document.getElementById("SaveTopic").style.visibility = "hidden";
			document.getElementById("SaveTopic").style.height = "0";
			document.postmodify.message.focus();
			document.images.prevwin.alt = "$npftxt{'05'}";
			document.images.prevwin.src="$imagesdir/preview0.gif";
		}
		tick();
	}

	function enabHelp() {
		if ( helpopen == false ) {
			helpopen = true
			document.getElementById("SaveFrame").style.visibility = "visible";
			document.getElementById("SaveFrame").style.height = "240";
			document.getElementById("SaveFrame").style.width = "760";
			document.getElementById("SaveTopic").style.visibility = "visible";
			document.getElementById("SaveTopic").style.height = "35";
			document.getElementById("SaveTopic").style.width = "750";
			document.postmodify.message.focus();
			document.images.helpwin.src="$imagesdir/preview1.gif";
			document.images.prevwin.alt = "$npftxt{'05'}";
			document.images.prevwin.src="$imagesdir/preview0.gif";
			autoprev = false
			showHelp();
		}
		else {
			helpopen = false
			document.getElementById("SaveFrame").style.visibility = "hidden";
			document.getElementById("SaveFrame").style.height = "0";
			document.getElementById("SaveTopic").style.visibility = "hidden";
			document.getElementById("SaveTopic").style.height = "0";
			document.postmodify.message.focus();
			document.images.helpwin.src="$imagesdir/help1.gif";
		}
	}

	function calcCharLeft() {
	  clipped = false
	  maxLength = $MaxMessLen
	  if (document.postmodify.message.value.length > maxLength) {
		document.postmodify.message.value = document.postmodify.message.value.substring(0,maxLength)
		if (ie && autosave) autoSaveMsg()
		charleft = 0
		clipped = true
	  } else {
		charleft = maxLength - document.postmodify.message.value.length
		if(ie && autosave) { calcCharSaved() }
	  }
	  prevsec++
	  if(autoprev && prevsec > 5 && prevtxt != document.postmodify.message.value) {
		autoPreview()
		prevtxt = document.postmodify.message.value
	  }
	  document.postmodify.msgCL.value = charleft
	  if (charleft >= 100 && noalert) { noalert = false; gralert = true; rdalert = true; clalert = true; document.images.chrwarn.src="$imagesdir/green1.gif"; }
	  if (charleft < 100 && charleft >= 50 && gralert) { noalert = true; gralert = false; rdalert = true; clalert = true; document.images.chrwarn.src="$imagesdir/green0.gif"; }
	  if (charleft < 50 && charleft > 0 && rdalert) { noalert = true; gralert = true; rdalert = false; clalert = true; document.images.chrwarn.src="$imagesdir/red0.gif" }
	  if (charleft == 0 && clalert) { noalert = true; gralert = true; rdalert = true; clalert = false; document.images.chrwarn.src="$imagesdir/red1.gif"; }
	  return clipped
	}

	var savedcnt = document.postmodify.message.value.length
	var savedsec = 0
	var savedtxt
	var savealert = false

	function calcCharSaved() {
		if (document.postmodify.message.value != savedtxt) {
			if ( savealert ) { savealert = false; document.images.savewarn.src="$imagesdir/red1.gif"; }
			savedsec++
			if ( document.postmodify.message.value.length > savedcnt || savedsec > 10 ) autoSaveMsg()
		}
		else { savedsec = 0 }
	}

	var sidestart = '<html><head>'
	var sidestyle = document.postmodify.holdstyle.value
	var sidestart1 = '</head><body onLoad="self.scrollTo(0,20000)"> <table cellpadding="3" cellspacing="0" border="0" height="100%" width="100%"><tr><td height="100%" valign="top" class="windowbg2"><font size="2">';
	var sideend = '</font></td></tr></table></body></html>';
	var codestr = '$simpelcode';
	var quotstr = '$normalquot';
	var squotstr = '$simpelquot';
	var dispname = '$settings[1]';
	var scrpurl = '$scripturl';
	var imgdir = '$imagesdir';
	var ubsmilieurl = '$smiliesurl';

	function autoPreview() {
		if (topicfirst)  { updatTopic(); }
		vismessage = document.postmodify.message.value;
		var ubbstr = jsDoUbbc(vismessage,codestr,quotstr,squotstr,dispname,scrpurl,imgdir,ubsmilieurl);
		SaveFrame.document.open("text/html","replace");
		SaveFrame.document.write(sidestart+sidestyle+sidestart1+ubbstr+sideend);
		SaveFrame.document.close();
		prevsec = 0
	}

	var topistart = '<html><head>'+sidestyle+'</head><body><table cellpadding="3" cellspacing="0" border="0" height="100%" width="100%"><tr><td height="100%" valign="middle" class="windowbg2"><font face="Verdana" size="2"><b>';
	var topiend = '</b></font></td></tr></table></body></html>';
	var visikon = '';

	function updatTopic() {
		topicfirst = false;
		~;
		if($post ne 'imsend') {
		$yymain .= qq~
		visicon = document.postmodify.icon.value;
		visicon=visicon.replace(/[^A-Za-z]/g, "");
		visicon=visicon.replace(/\\\\/g, "");
		visicon=visicon.replace(/\\//g, "");
		if (visicon != "xx" && visicon != "thumbup" && visicon != "thumbdown" && visicon != "exclamation") {
			if (visicon != "question" && visicon != "lamp" && visicon != "smiley" && visicon != "angry") {
				if (visicon != "cheesy" && visicon != "laugh" && visicon != "sad" && visicon != "wink") {
					visicon = "xx";
				}
			}
		}
		visikon = "<img border='0' src='$imagesdir/"+visicon+".gif' alt='"+visicon+"'> ";
		~;
		}
		$yymain .= qq~
		vistopic = document.postmodify.subject.value;
		var htmltopic = jsDoTohtml(vistopic);
		SaveTopic.document.open("text/html","replace");
		SaveTopic.document.write(topistart+visikon+htmltopic+topiend);
		SaveTopic.document.close();
		document.postmodify.message.focus();
	}

	var sidestart2 = '</head><body><table cellpadding="10" cellspacing="0" border="0" height="100%" width="100%" align="center"><tr><td height="100%" valign="top" class="windowbg2"><font size="2">';

	function showHelp() {
		var helptitle = "$npftxt{'13'}";
		SaveTopic.document.open("text/html","replace");
		SaveTopic.document.write(topistart+helptitle+topiend);
		SaveTopic.document.close();
		helptext = '$hlptext';
		SaveFrame.document.open("text/html","replace");
		SaveFrame.document.write(sidestart+sidestyle+sidestart2+helptext+sideend);
		SaveFrame.document.close();
		document.postmodify.message.focus();
	}

	function autoSaveMsg() {
		document.postmodify.msgCB.value = document.postmodify.message.value.length
		document.postmodify.message.createTextRange().execCommand("Copy")
		savedcnt = document.postmodify.message.value.length + 50
		savedtxt = document.postmodify.message.value
		savedsec = 0
		document.images.savewarn.src="$imagesdir/green1.gif"
		savealert = true
	}

	tick();
	//-->
	</script>
~;
}
$yymain.=qq~
<script language="JavaScript"> <!--
   document.postmodify.$settofield.focus();
//--> </script>
~;
}

sub Preview {
	&clear_temp;
	$poll_question = $FORM{'question'};
	$numpolloptions ||= 8;
	for(my $i = 1; $i <= $numpolloptions; $i++) {$options[$i] = $FORM{"option$i"};}
	$guest_vote = $FORM{'guest_vote'};
	$hide_results = $FORM{'hide_results'};
	$multi_choice = $FORM{'multi_choice'};
	$poll_comment = $FORM{'poll_comment'};
	$pollthread =  $FORM{'pollthread'} || 0;

	$name = $FORM{'name'};
	$email = $FORM{'email'};
	$sub = $FORM{'subject'};
	$FORM{'message'} =~ s~\r~~g;
	$mess = $FORM{'message'};
	$message = $FORM{'message'};
 	$icon = $FORM{'icon'};
	$ns = $FORM{'ns'};
	$threadid = $FORM{'threadid'};
	$notify = $FORM{'notify'};
	$postid = $FORM{'postid'};
	if (length($sub) > 50) { $sub = substr($sub,0,50); }
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1$2~g;
	&ToHTML($message);
	$message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
	$message =~ s/\n/<br>/g;
	&CheckIcon;

	if($icon eq "xx") { $ic1 = " selected"; }
	elsif($icon eq "thumbup") { $ic2 = " selected"; }
	elsif($icon eq "thumbdown") { $ic3 = " selected"; }
	elsif($icon eq "exclamation") { $ic4 = " selected"; }
	elsif($icon eq "question") { $ic5 = " selected"; }
	elsif($icon eq "lamp") { $ic6 = " selected"; }
	elsif($icon eq "smiley") { $ic7 = " selected"; }
	elsif($icon eq "angry") { $ic8 = " selected"; }
	elsif($icon eq "cheesy") { $ic9 = " selected"; }
	elsif($icon eq "laugh") { $ic10 = " selected"; }
	elsif($icon eq "sad") { $ic11 = " selected"; }
	elsif($icon eq "wink") { $ic12 = " selected"; }

	$name_field = $realname eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'44'}:</b></font></td>
    <td class="windowbg"><input type=text name="name" size=25 value="$FORM{'name'}" maxlength="25" tabindex="2"></td>
      </tr>~ : qq~~;

	$email_field = $realemail eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'69'}:</b></font></td>
    <td class="windowbg"><input type=text name="email" size=25 value="$FORM{'email'}" maxlength="40" tabindex="3"></td>
      </tr>~ : qq~~;
	if ($FORM{'notify'} eq "x") {$notify = " checked";}
	if ($FORM{'ns'} eq 'NS') {$nscheck = " checked";}

	if ($username eq 'Guest') {
		fopen(FILE, "$memberdir/memberlist.txt") || &fatal_error("202 $txt{'106'}: $txt{'23'} memberlist.txt");
		@memberlist = <FILE>;
		fclose(FILE);
		$testname = lc $name;
		for ($a = 0; $a < @memberlist; $a++) {
			chomp $memberlist[$a];
			$membername = lc $memberlist[$a];
			if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {
				$tmpa = <FILE2>;
				$realname = <FILE2>;
				fclose(FILE2);
				chomp $realname;
				$realname = lc $realname;
				if ($realname eq $testname || $membername eq $testname) { &fatal_error($txt{'100'}); }
			}
			elsif( $testname eq $membername ) { &fatal_error($txt{'100'}); }
		}
		fopen(FILE, "$vardir/reserve.txt") || &fatal_error("203 $txt{'106'}: $txt{'23'} reserve.txt");
		@reserve = <FILE>;
		fclose(FILE);
		fopen(FILE, "$vardir/reservecfg.txt") || &fatal_error("204 $txt{'106'}: $txt{'23'} reservecfg.txt");
		@reservecfg = <FILE>;
		fclose(FILE);
		for( $a = 0; $a < @reservecfg; $a++ ) {
			chomp $reservecfg[$a];
		}
		$matchword = $reservecfg[0] eq 'checked';
		$matchcase = $reservecfg[1] eq 'checked';
		$matchuser = $reservecfg[2] eq 'checked';
		$matchname = $reservecfg[3] eq 'checked';
		$namecheck = $matchcase eq 'checked' ? $name : lc $name;
		foreach $reserved (@reserve) {
			chomp $reserved;
			$reservecheck = $matchcase ? $reserved : lc $reserved;
			if ($matchname) {
				if ($matchword) {
					if ($namecheck eq $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
				else {
					if ($namecheck =~ $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
			}
		}
	}
################ Media Player mod
		if ($username ne 'Guest') {
			$mediausername = $settings[1];
		} else{
			$mediausername = $FORM{'name'};
		}
################ Media Player mod end
	&wrap;
	$displayname = $settings[1];
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	&wrap2;
	if( $FORM{'previewmodify'} ) {
		$submittxt = "$txt{'10'}";
		$is_preview = 1;
		$post = "postmodify";
		$preview = "previewmodify";
		$destination = 'modify2';
		$submittxt = $txt{'10'};
	}
	elsif( $FORM{'previewim'} ) {
		$submittxt = "$txt{'148'}";
		$destination = "imsend2";
		$is_preview = 1;
		$post = "imsend";
		$preview = "previewim";
		$submittxt = $txt{'148'};
	}
	else {
		$notification = ! $enable_notification || $username eq 'Guest' ? '' : <<"~;";
    <tr>
      <td class="windowbg"><font size=2><b>$txt{'131'}:</b></font></td>
      <td class="windowbg"><input type=checkbox name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
    </tr>
~;
		$destination = 'post2';
		$submittxt = $txt{'105'};
		$is_preview = 1;
		$post = "post";
		$preview = "preview";
	}

	if($INFO{'action'} eq "imgroups") { $destination = "imgroups"; }


	$csubject = $sub;
	&LoadCensorList;	# Load Censor List
	$csubject =~ s/\Q$tmpa\E/$tmpb/gi;
	$message =~ s/\Q$tmpa\E/$tmpb/gi;

	$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript" src="$ubbcjspath"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
function showimage() {
   document.images.icons.src="$imagesdir/"+document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value+".gif";
}
//-->
</script>
<table border=0 width="90%" cellspacing=1 cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}"><font size=2 class="text1" color="$color{'titletext'}">
    <img src="$imagesdir/$icon.gif" name="icons" border=0> $csubject</font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><BR>$message<BR><BR></font></td>
  </tr>
</table>
<BR>
~;
	$message = $mess; 
	$yytitle = "$txt{'507'} - $csubject";
	$settofield="message";
	&Postpage;
	&template;
	exit;
}

sub Post2 {
	if($username eq 'Guest' && $enable_guestposting == 0) {	&fatal_error($txt{'165'}); }
	my( $email, $subject, $ns, $threadid, $notify, @memberlist, $a, $realname, $membername, $testname, @reserve, @reservecfg, $matchword, $matchcase, $matchuser, $matchname, $namecheck, $reserved, $reservecheck, $newthreadid, @messages, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $start, $pageindex, $tempname );

	# If poster is a Guest then evaluate the legality of name and email
	if(!$settings[2]) {
		$FORM{'name'} =~ s/\A\s+//;
		$FORM{'name'} =~ s/\s+\Z//;
		&fatal_error($txt{'75'}) unless ($FORM{'name'} ne '' && $FORM{'name'} ne '_' && $FORM{'name'} ne ' ');
		&fatal_error($txt{'568'}) if(length($FORM{'name'}) > 25);
		&fatal_error("$txt{'76'}") if($FORM{'email'} eq '');
		&fatal_error("$txt{'240'} $txt{'69'} $txt{'241'}") if($FORM{'email'} !~ /[\w\-\.\+]+\@[\w\-\.\+]+\.(\w{2,4}$)/);
		&fatal_error("$txt{'500'}") if(($FORM{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($FORM{'email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));
	}

	# Get the form values
	$name = $FORM{'name'};
	$email = $FORM{'email'};
	$subject = $FORM{'subject'};
	$message = $FORM{'message'};
 	$icon = $FORM{'icon'};
	$ns = $FORM{'ns'};
	$threadid = $FORM{'threadid'};
	if( $threadid =~ /\D/ ) { &fatal_error($txt{'337'}); }
	$notify = $FORM{'notify'};

	if($name && $email) {
		&ToHTML($name);
		$email =~ s/\|//g;
		&ToHTML($email);
		$tempname = $name;	# hold it temporarily so we can put the _'s back later
		$name =~ s/\_/ /g;
	}

	&fatal_error($txt{'75'}) unless($username || $name);
	&fatal_error($txt{'76'}) unless($settings[2] || $email);
	$pollthread = $FORM{'pollthread'} || 0;
	if ($pollthread != 2) {	# If user is NOT adding a Poll to an existing thread
	&fatal_error($txt{'77'}) unless($subject && $subject !~ m~\A[\s_.,]+\Z~);
	&fatal_error($txt{'78'}) unless($message);
	if (length($message)>$MaxMessLen) { &fatal_error($txt{'499'}); }

	if( $FORM{'preview'} ) { &Preview; }
	&spam_protection;

	if (length($subject) > 50) { $subject = substr($subject,0,50); }
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&ToHTML($message);
	$message =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$message =~ s~\n~<br>~g;
	&CheckIcon;

	if(-e("$datadir/.txt")) { unlink("$datadir/.txt"); }

	} # end if


	if ($username ne 'Guest') {
		# If not guest, get name and email.
		$name = $settings[1];
		$email = $settings[2];
	} else {
		# If user is Guest, then make sure the chosen name
		# is not reserved or used by a member.
		fopen(FILE, "$memberdir/memberlist.txt") || &fatal_error("206 $txt{'106'}: $txt{'23'} $memberlist.txt");

		@memberlist = <FILE>;
		fclose(FILE);
		$testname = lc $name;
		for ($a = 0; $a < @memberlist; $a++) {
			chomp $memberlist[$a];
			$membername = lc $memberlist[$a];
			if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {
				$tmpa = <FILE2>;
				$realname = <FILE2>;
				fclose(FILE2);
				chomp $realname;
				$realname = lc $realname;
				if ($realname eq $testname || $membername eq $testname) { &fatal_error($txt{'473'}); }
			}
			elsif( $testname eq $membername ) { &fatal_error($txt{'473'}); }
		}

		fopen(FILE, "$vardir/reserve.txt") || &fatal_error("207 $txt{'106'}: $txt{'23'} reserve.txt");
		@reserve = <FILE>;
		fclose(FILE);
		fopen(FILE, "$vardir/reservecfg.txt") || &fatal_error("208 $txt{'106'}: $txt{'23'} reservecfg.txt");
		@reservecfg = <FILE>;
		fclose(FILE);
		for( $a = 0; $a < @reservecfg; $a++ ) { chomp $reservecfg[$a]; }
		$matchword = $reservecfg[0] eq 'checked';
		$matchcase = $reservecfg[1] eq 'checked';
		$matchuser = $reservecfg[2] eq 'checked';
		$matchname = $reservecfg[3] eq 'checked';
		$namecheck = $matchcase eq 'checked' ? $name : lc $name;

		foreach $reserved (@reserve) {
			chomp $reserved;
			$reservecheck = $matchcase ? $reserved : lc $reserved;
			if ($matchname) {
				if ($matchword) {
					if ($namecheck eq $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
				else {
					if ($namecheck =~ $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
			}
		}
		$name = $tempname; # put the name back (with any _'s) now that we've checked it
	}


## [Poll Mod] ##
	my @poll_data;
	if ($pollthread) {	
		$maxpq ||= 60;
		$maxpo ||= 50;
		$maxpc ||= 0;
		$numpolloptions ||= 8;

		$numcount = 0;
		if ( length($FORM{"question"} ) > $maxpq) { &fatal_error("$polltxt{'40'} $polltxt{'34a'} $maxpq $polltxt{'34b'} $polltxt{'36'}"); }
		&ToHTML($FORM{"question"});
		$guest_vote = $FORM{'guest_vote'} || 0;
		$hide_results = $FORM{'hide_results'} || 0;
		$multi_choice = $FORM{'multi_choice'} || 0;
		$poll_comment = $FORM{'poll_comment'} || "";
		if ( length($poll_comment ) > $maxpc) { &fatal_error("$polltxt{'57'} $polltxt{'34a'} $maxpc $polltxt{'34b'} $polltxt{'36'}"); }
		&ToHTML($poll_comment);
		$poll_comment =~ s~\n~<br>~g;
		$poll_comment =~ s~\r~~g;
		push @poll_data, qq~$FORM{"question"}|0|$username|$name|$email|$date|$guest_vote|$hide_results|$multi_choice|||$poll_comment\n~;

		for ($i = 1; $i <= $numpolloptions; $i++){
			if ($FORM{"option$i"}) {
				if (length($FORM{"option$i"}) > $maxpo) { &fatal_error("$polltxt{'7'} $i  $polltxt{'34a'} $maxpo $polltxt{'34b'} $polltxt{'36'}"); }
				&ToHTML($FORM{"option$i"});
				$numcount++;
				push @poll_data, qq~0|$FORM{"option$i"}\n~;
			}
		}
		unless ($FORM{"question"}) { &fatal_error("$polltxt{'37'}"); }
		if ($numcount < 2) { &fatal_error("$polltxt{'38'}"); }
	}
## [/Poll Mod] ##

######################################
## DaveB's File Attachment Mod v2.5 ##
######################################

if ($FORM{'file'}) {
if (!$FORM{'post'} && !$FORM{'postmodify'}) { &write_error("$fatxt{'49'}"); }
$mylimit = 1024 * $limit;
$mydirlimit = 1024 * $dirlimit;

$file = $filename;
$file =~ s/.+\\([^\\]+)$|.+\/([^\/]+)$/$1/;
$file =~ s/[#%+,\/:?"<>'|@^!]//g;	#edit in between [ ] to include characters you dont want to allow in filenames (dont put a . there or you wont be able to get any file extensions).
$file =~ s/ /_/g;			#replaces spaces in filenames with a "_" character.

opendir(AMD, $upload_dir) || &write_error("$fatxt{'19'} $upload_dir.");
@dirlist = readdir(AMD);
closedir(AMD);

foreach $dirlist(@dirlist)
   {
          if (lc $dirlist eq lc $file) { &write_error("$fatxt{'8'}"); last;} 

   }

if ($checkext == 0) { $match = 1; } else {
foreach $ext (@ext){
	chomp ($ext);
		if (grep /$ext$/i,$file){$match=1; last;}
	}
}
if ($match) {
	if ($allowattach == 1 && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) { 
		$upload_okay = 1;
	}
} else {
		&write_error("$fatxt{'20'} @ext"); 
	}

if ($mydirlimit > 0) {
	&dirstats;
}

$filesize = $ENV{'CONTENT_LENGTH'} - $postsize;
$filesizekb = int ($filesize/1024);
if ($filesize > $mylimit && $mylimit != 0) {
	$filesizediff = $filesizekb - $limit;
	if ($filesizediff == 1) { $sizevar = "kilobyte"; } else { $sizevar = "kilobytes"; }
	&write_error("$fatxt{'21'} $filesizediff $sizevar $fatxt{'21b'}");
} elsif ($filesize > $spaceleft && $mydirlimit != 0) {	
	$filesizediff = $filesizekb - $kbspaceleft;
	if ($filesizediff == 1) { $sizevar = "kilobyte"; } else { $sizevar = "kilobytes"; }
	&write_error("$fatxt{'22'} $filesizediff $sizevar $fatxt{'22b'}");
}

$write_file = "$upload_dir/$file";
$save_file = "$http_dir/$file"; 

}

#######################################
## /DaveB's File Attachment Mod v2.5 ##
#######################################		

	# If no thread specified, this is a new thread.
	# Find a valid random ID for it.
	if($threadid eq '') {
		$newthreadid = time;
		$i=0;
		if (-e "$datadir/$newthreadid.txt") {
			while (-e "$datadir/$newthreadid$i.txt") { ++$i; }
			$newthreadid="$newthreadid$i";
		}
	}
	else { $newthreadid = ''; }

	if($newthreadid) {
		# This is a new thread. Save it.
		fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &write_error("210 $txt{'106'}: $txt{'23'} $currentboard.txt");
			seek FILE, 0, 0;
			my @buffer = <FILE>;
			truncate FILE, 0;
			seek FILE, 0, 0;
			print FILE qq~$newthreadid|$subject|$name|$email|$date|0|$username|$icon|0\n~;
			print FILE @buffer;
		fclose(FILE);
		fopen(FILE, ">$datadir/$newthreadid.txt") || &write_error("$txt{'23'} $newthreadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||$save_file|$file\n~;
		fclose(FILE);
		$mreplies = 0;
		if ($file) {
		fopen(AMP, ">>$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		print AMP qq~$newthreadid|$mreplies|$subject|$name|$currentboard|$filesizekb|$date|$file\n~;
		fclose(AMP);
		}
		if ($pollthread) { # Save Poll data for new thread
			fopen (POLL, ">$datadir/$newthreadid.poll");
			print POLL @poll_data;
			fclose (POLL);
			fopen(FILE, ">>$boardsdir/polls.poll") || &fatal_error("300 $txt{'106'}: $txt{'23'} polls.poll");
			print FILE "$newthreadid|$currentboard\n";
			fclose(FILE);
		}
	} else {
		# This is an old thread. Save it.
		if ($pollthread) { # Save new Poll data
			fopen (POLL, ">$datadir/$threadid.poll");
			print POLL @poll_data;
			fclose (POLL);
			fopen(FILE, ">>$boardsdir/polls.poll") || &fatal_error("300 $txt{'106'}: $txt{'23'} polls.poll");
			print FILE "$threadid|$currentboard\n";
			fclose(FILE);
			$yySetLocation = qq~$cgi;action=display;num=$threadid~;
			&redirectexit;
		} else { # or save new reply data
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$yyThreadLine);
		if( $mstate == 1 ) { &fatal_error($txt{'90'}); }
		++$mreplies;
		fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &write_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
			seek FILE, 0, 0;
			my @buffer = <FILE>;
			truncate FILE, 0;
			for ($a = 0; $a < @buffer; $a++) {
				if ( $buffer[$a] =~ m~\A$mnum\|~o ) { $buffer[$a] = ""; last; }
			}
			seek FILE, 0, 0;
			print FILE qq~$mnum|$msub|$mname|$memail|$date|$mreplies|$musername|$micon|$mstate\n~;
			print FILE @buffer;
		fclose(FILE);
		fopen(FILE, ">>$datadir/$threadid.txt") || &write_error("212 $txt{'106'}: $txt{'23'} $threadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||$save_file|$file\n~;
		fclose(FILE);
		if ($file) {
		fopen(AMP, ">>$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		print AMP qq~$mnum|$mreplies|$subject|$name|$currentboard|$filesizekb|$date|$file\n~;
		fclose(AMP);
		}

		} # end else

	}

	if($username ne 'Guest') {
		# Increment post count for the member.
		$settings[6] =~ s/[\n\r]//g;
		++$settings[6];
		fopen(FILE, ">$memberdir/$username.dat") || &fatal_error("213 $txt{'106'}: $txt{'23'} $username.dat");
		foreach (@settings) {
			print FILE qq~$_\n~;
		}
		fclose(FILE);
	}

	# The thread ID, regardless of whether it's a new thread or not.
	$thread = $newthreadid || $threadid;

	# Update totals for this board.
	&doaddition;

	# Mark thread as read for the member.
	&dumplog($currentboard,$date);

######################################
## DaveB's File Attachment Mod v2.5 ##
######################################
if ($upload_okay == 1) {
	if($servertype == 0) {
		eval { use File::Copy; };
		unless($@) {
		close($filename);
		move("$tmpfile", "$write_file") || &write_error("Error renaming '$tmpfile' to '$write_file'!");
		} else { &fatal_error("File::Copy module either not present or producing errors. Please override by having the administrator select the web server type in the forum settings section."); }
	} elsif ($servertype == 1) {
		fopen(AMT, ">$write_file")||&write_error("$fatxt{'19'} $write_file. $!");
		binmode AMT;
		# binmode is for windows only. Ignored by unix
		while ($bytesread=read($filename,$buffer,1024)) { print AMT $buffer; }
		fclose(AMT);	
		chmod (0666, "$write_file");
		close($filename);
		1;
	} elsif ($servertype == 2) {
		close($filename);
		rename $tmpfile, $write_file || &write_error("Error renaming '$tmpfile' to '$write_file'!");
		1;
	}
&clear_temp;
}
#######################################
## /DaveB's File Attachment Mod v2.5 ##
#######################################

	# Let's figure out what page number to show
	$start = 0;
	$pageindex = int($mreplies / $maxmessagedisplay);
	$start = $pageindex * $maxmessagedisplay;

	# Notify any members who have notification turned on for this thread.
	if(-e("$datadir/$thread.mail")) { &NotifyUsers; }

	if($notify) {
		$INFO{'thread'} = $thread;
		$INFO{'start'} = $start;
		require "$sourcedir/Notify.pl";
		&Notify2;
	}
	$yySetLocation = qq~$cgi;action=display;num=$thread;start=$start#$mreplies~;
		if (-e "$memberdir/$username.zod") {
			fopen(FILE, "$memberdir/$username.zod");
			@mzodfile = <FILE>;
			chomp $mzodfile[0];
			fclose(FILE);
		}
	fopen(FILE, ">$memberdir/$username.zod");
	print FILE qq~$mzodfile[0]~;
	fclose(FILE);
	&redirectexit;
}

sub NotifyUsers {
	$subject = $FORM{'subject'};

	fopen(FILE, "$datadir/$thread.mail") || return 0;
	@mails = <FILE>;
	fclose(FILE);
	foreach $curmail (@mails) {
		chomp $curmail;
		if ($curmail ne $settings[2]) {
			&sendmail($curmail,"$txt{'127'}\:  $subject","$txt{'128'}, $subject, $txt{'129'} $cgi;action=display;num=$thread\n\n$txt{'130'}");
		}
	}
	return 1;
}

sub doshowthread {
	my( $line, $trash, $tempname, $tempdate, $temppost );

	&LoadCensorList;	# Load Censor List

	if (@messages) {
		$yymain .= qq~
	<BR><BR>
	<table cellspacing=1 cellpadding=0 width="90%" align="center" bgcolor="$color{'bordercolor'}" class="bordercolor">
	<tr><td>
	<table class="windowbg" cellspacing="1" cellpadding="2" width="100%" align=center bgcolor="$color{'windowbg'}">
	<tr><td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font size="2" class="text1" color="$color{'titletext'}">
	<b>$txt{'468'}</b>
	</font></td></tr>~;
		foreach $line (@messages) { #start for each

			($trash, $tempname, $trash, $tempdate, $trash, $trash, $trash, $trash, $message, $ns) = split(/\|/,$line);
			$tempdate = &timeformat($tempdate);
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$message =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			my @words = split(/\s/,$message);
################ Media Player mod
			$mediausername = $tempname;
################ Media Player mod end
			&wrap;
			$displayname = $tempname;
			if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
			&wrap2;
			$yymain .= qq~

<tr><td align=left class="catbg">
<font size="1">$txt{'279'}: $tempname</font></td>
<td class="catbg" align=right>
<font size="1">$txt{'280'}: $tempdate</font></td>
</tr>
<tr><td class="windowbg2" colspan=2 bgcolor="$color{'windowbg2'}">
<font size="1">$message</font>
</td></tr>~;
		}
		$yymain .= "</table></td></tr></table>\n";
	}
	else { $yymain .= "<!--no summary-->"; }
}

sub doaddition {
	fopen(FILE2, "$datadir/$thread.data");
	$tempinfo = <FILE2>;
	fclose(FILE2);

	($views, $lastposter) = split(/\|/,$tempinfo);

	my( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($currentboard);
	++$messagecount;
	unless( $FORM{'threadid'} ) {
		++$threadcount;
	}
	$myname = $username eq 'Guest' ? qq~Guest-$name~ : $username;
	&BoardCountSet( $currentboard, $threadcount, $messagecount, $date, $myname );

	fopen(FILE2, "+>$datadir/$thread.data");
	print FILE2 "$views|$myname";
	fclose(FILE2);
}

1;
